<template>
  <div id="map">
  </div>
</template>

<script>
import { loader } from 'src/api/googleMapsApi'

export default {
  name: 'GoogleMaps',
  props: {
    markers: Array
  },
  watch: {
    markers (newValue) {
      loader.then(google => this.loadMarkers(google))
    }
  },
  data: () => {
    return {
      map: null,
      mapCenter: {
        coordinates: { lat: 51.08914164420478, lng: 17.011763340604737 },
        marker: null
      }
    }
  },
  computed: {
    // eslint-disable-next-line vue/no-async-in-computed-properties
    async currentLocation () {
      // eslint-disable-next-line vue/no-async-in-computed-properties
      const currentLocation = await this.$getLocation({})
      if (!this.map) this.map.setCenter(currentLocation)
      return currentLocation
    }
  },
  methods: {
    async updateCenterMarker (google) {
      const newLocation = await this.$getLocation({})
      if (this.mapCenter.coordinates.lat !== newLocation.lat || this.mapCenter.coordinates.lng !== newLocation.lng) {
        this.mapCenter.coordinates = newLocation
        this.map.setCenter(this.mapCenter.coordinates)
        if (this.mapCenter.marker != null) this.mapCenter.marker.setMap(null)
        this.mapCenter.marker = new google.maps.Marker({
          position: this.mapCenter.coordinates,
          map: this.map,
          icon: {
            path: google.maps.SymbolPath.CIRCLE,
            scale: 10,
            fillOpacity: 1,
            strokeWeight: 2,
            fillColor: '#5384ED',
            strokeColor: '#ffffff'
          }
        })
      }
    },
    async loadMarkers (google) {
      return this.markers.map(marker => {
        // eslint-disable-next-line no-new
        new google.maps.Marker({
          position: marker.position,
          map: this.map,
          title: marker.title
        })
      })
    }
  },
  async mounted () {
    const google = await loader
    this.mapCenter.coordinates = await this.$getLocation({})
    this.map = new google.maps.Map(document.getElementById('map'), {
      zoom: 14,
      center: this.mapCenter.coordinates
    })
    const availableMarkers = await this.loadMarkers(google)
    console.log(JSON.stringify(availableMarkers))
    this.mapCenter.marker = new google.maps.Marker({
      position: this.mapCenter.coordinates,
      map: this.map,
      icon: {
        path: google.maps.SymbolPath.CIRCLE,
        scale: 10,
        fillOpacity: 1,
        strokeWeight: 2,
        fillColor: '#5384ED',
        strokeColor: '#ffffff'
      }
    })
    setInterval(() => { this.updateCenterMarker(google) }, 2000)
  }
}
</script>

<style scoped>
  #map {
    width: 100%;
    height: 462px;
    margin: auto;
  }
</style>
